// GanymeApplet.java 

import java.applet.Applet;
import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.io.*;
	
class GanymeDots 
// Shbg̃Zbg
{

	int dot [] = new  int [4];
	
	int get (int p) 
	// p Ԗڂ̃hbg̒lԂB
	{
		return dot [p];
	}
 
	void set (int p, int v) 
	// p Ԗڂ̃hbg̒l v ɐݒ肷B
	{
		dot [p] = v;
	}




 
	boolean isEqual (GanymeDots dt) 
	// dt ƓeȂ^ԂB
	{
		for (int i=0; i<4; i++)
			if (dot [i] != dt.dot [i])
				return false;
		return true;
	}
 
} // class GanymeDots 
  
class GanymeFile extends Thread 
// ʃXbh URL t@CǂݍށB
{
	int max; // t@C̍őoCg
	int cur; // ܂łɓǂݍłoCg
	int pos; // seek ̈ʒu
	byte mem []; // obt@
	InputStream is; // ǂݍ݃Xg[
	
	GanymeFile (URL url) 
	{
		max = cur = pos = 0;

		try {
			is = new BufferedInputStream (url.openStream ());

			// 擪̂UoCgɓǂݍ
			byte [] hb = new byte [6]; // Head Byte
			mem = hb;
			is.read (hb);
			cur = max = 6;

			// tH[}bg̃`FbN
			String s = new String (readBytes (2));
			if (!s.equals ("CA") && !s.equals ("GA")) return;

			// t@CTCYɃTCY
			max = readInt ();
			mem = new byte [max];
			for (cur=0; cur<6; cur++)
				mem [cur] = hb [cur];
		} catch (IOException e) {
		}
	}
 
	public void run () 
	// RXgN^̓ǂݍ݂̑
	{
		try {
			while (cur < max) {
				int bt = is.read ();
				if (bt == -1) break;
				mem [cur++] = (byte)bt;
			}
			is.close ();
		} catch (IOException e) {
		}
	}
 
	public void seek (int ps) 
	// V[NʒuΈʒu ps ɐݒ肷B
	{
		if (ps > max || ps < 0) return;
		pos = ps;
	}
 
	public byte [] readBytes (int sz) 
	// sz  byte zǂݍށB
	{
		byte [] bt = new byte [sz];
		for (int i=0; i<sz; i++)
			bt [i] = readByte ();
		return bt;
	}
 
	public int readInt () 
	// int lǂݍ
	{
		int it = 0;
		for (int i=0; i<4; i++) {
			int bt = readByte ();
			bt &= 0xff;
			it |= bt << (8 * i);
		}
		return it;
	}
 
	public short readShort () 
	// short lǂݍ
	{
		short st = 0;
		for (int i=0; i<2; i++) {
			int bt = readByte ();
			bt &= 0xff;
			st |= bt << (8 * i);
		}
		return st;
	}

 
	public byte readByte () 
	// byte lǂݍ
	{
		while (pos >= cur)
			try {
				sleep (1);
			} catch (java.lang.InterruptedException e) {}
		return mem [pos++];
	}
 
	public void skipString () 
	// NULL ܂ł𕶎Ƃēǂݔ΂B
	{
		while (readByte () != 0);
	}
 
	public int tell () 
	// V[NʒuԂB
	{
		return pos;
	}
 
} 
  
class GanymeScreen 
// ItXN[ɕ`悷B
{
	MemoryImageSource memImage; // C[W
	int width, height; // Ac
		public void setWidth (int w) { width = w; }
		public void setHeight (int h) { height = h; }
		public int getWidth () { return width; }
		public int getHeight () { return height; }
	int hiR, hiG, hiB; // nCCg RGB l
	byte [] data, loop; // ݗpƃ[vp̃obt@
		public void saveLoop () { System.arraycopy (data, 0, loop, 0, data.length); }
		public void loadLoop () { System.arraycopy (loop, 0, data, 0, loop.length); }
	boolean drawFlag; // O 4bit ̂ǂɓǂݏ邩B
		public void setDrawFlag (boolean f) { drawFlag = f; }
	int [] baseR, baseG, baseB; // {ƂȂ RGB l
	int [] curR, curG, curB; // ̃t[ RGB l
	int [] preR, preG, preB; // Õt[ RGB l
	byte [] outR, outG, outB; // o͂ RGB l
	int lumino; // ̃t[̖邳


	
	GanymeScreen () 
	{
		hiR = hiG = hiB = 255; // nCCg͔

		baseR = new int [16];
		baseG = new int [16];
		baseB = new int [16];

		curR = new int [16];
		curG = new int [16];
		curB = new int [16];

		preR = new int [16];
		preG = new int [16];
		preB = new int [16];

		outR = new byte [256];
		outG = new byte [256];
		outB = new byte [256];
	}
 
	public void setSize (int w, int h) 
	// TCY (w, h) ɐݒ
	{
		width = w;
		height = h;

		// obt@̍Ċm
		data = new byte [width * height];
		loop = new byte [width * height];

		// 
		for (int i=0; i<256; i++) outR [i] = outG [i] = outB [i] = 0;
		ColorModel cm = new IndexColorModel (8, 256, outR, outG, outB);
		memImage = new MemoryImageSource (w, h, cm, data, 0, w);
		memImage.setAnimated (true);
//		memImage.setFullBufferUpdates (true);
	}
 
	public void setGrade (int gr) 
	// ~ gr ɍ킹 RBG l
	{
		if (gr > 16)
			gr = 16;
		if (gr < 2)
			gr = 2;

		int r, g, b;
		gr--;
		for (int i=0; i<=gr; i++) {
			r = hiR * i / gr;
			g = hiG * i / gr;
			b = hiB * i / gr;
			setBaseRGB (i, r, g, b);
		}
	}
 
	public void copyPrev (int x, int y, int w, int h) 
	// Õt[̋` (x, y, w, h) ̃t[ɃRs[
	{
		if (w == 0 || h == 0) return;
		int x2 = x + w;
		int y2 = y + h;
		for (int y1=y; y1<y2; y1++)
			for (int x1=x; x1<x2; x1++)
				setDot (x1, y1, getPrev (x1, y1));
	}
 
	public void setDot (int x, int y, int v) 
	// W (x, y) ̒l v ɃZbg
	{
		int p = width * y + x;
		int d = data [p];
		if (drawFlag) {
			d &= 0x0f;
			d |= v << 4;
		} else {
			d &= 0xf0;
			d |= v;
		}
		data [p] = (byte)d;
	}
 
	public int getPrev (int x, int y) 
	// Õt[̍W (x, y) ̒lԂB
	{
		int p = width * y + x;
		int d = data [p];
		if (drawFlag) {
			d &= 0x0f;
		} else {
			d >>= 4;
			d &= 0x0f;
		}
		return d;
	}
 
	public int getDot (int x, int y) 
	// W (x, y) ̒lԂB
	{
		int p = width * y + x;
		int d = data [p];
		if (drawFlag) {
			d >>= 4;
			d &= 0x0f;
		} else {
			d &= 0x0f;
		}
		return d;
	}
 
	public GanymeDots prevDots (int x, int y) 
	// Õt[̍W (x, y) 牡ɂS̃hbgԂB
	{
		GanymeDots dt = new GanymeDots ();
		for (int i=0; i<4; i++)
			dt.set (i, getPrev (x + i, y));
		return dt;
	}
 
	public GanymeDots getDots (int x, int y) 
	// W (x, y) 牡ɂS̃hbgԂB
	{
		GanymeDots dt = new GanymeDots ();
		for (int i=0; i<4; i++)
			dt.set (i, getDot (x + i, y));
		return dt;
	}
 
	public void setDots (GanymeDots dt, int x, int y) 
	// W (x, y) 牡ɂS̃hbgݒ
	{
		for (int i=0; i<4; i++)
			setDot (x + i, y, dt.get (i));
	}
 
	public void setLumino (int lm) 
	// ̃t[̖邳 lm ɐݒ
	{
		lumino = lm;
		lm -= 50;

		copyPrevRGB ();

		int c = 16;
		if (lm == 0) {
			while (c-- > 0) {
				setCurRGB (c, baseR [c], baseG [c], baseB [c]);
			}
		} else if (lm > 0) {
			int rx = hiR * lm / 50;
			int ry = hiR - rx;
			int gx = hiG * lm / 50;
			int gy = hiG - gx;
			int bx = hiB * lm / 50;
			int by = hiB - bx;
			while (c-- > 0) {
				int r = rx + ry * baseR [c] / hiR;
				int g = gx + gy * baseG [c] / hiG;
				int b = bx + by * baseB [c] / hiB;
				setCurRGB (c, r, g, b);
			}
		} else { // lm < 0
			while (c-- > 0) {
				int r = baseR [c] * (50 + lm) / 50;
				int g = baseG [c] * (50 + lm) / 50;
				int b = baseB [c] * (50 + lm) / 50;
				setCurRGB (c, r, g, b);
			}
		}
	}
 
	public void setBaseRGB (int c, int r, int g, int b) 
	// c Ԗڂ̊{ƂȂ RGB l (r, g, b) ɐݒ
	{
		baseR [c] = r;
		baseG [c] = g;
		baseB [c] = b;
	}
 
	public void setCurRGB (int c, int r, int g, int b) 
	// c Ԗڂ̍̃t[ RGB l (r, g, b) ɐݒ
	{
		curR [c] = r;
		curG [c] = g;
		curB [c] = b;
	}
 
	void copyPrevRGB () 
	// Õt[ RGB l̃t[ RGB lɃRs[
	{
		System.arraycopy (curR, 0, preR, 0, 16);
		System.arraycopy (curG, 0, preG, 0, 16);
		System.arraycopy (curB, 0, preB, 0, 16);
	}
 
	void update (int ct, int pt) 
	// Õt[ƍ̃t[iKIɍ
	// ct ... ̃t[̍ (CurTime)
	// pt ... Õt[̍ (PreTime)
	{
		for (int i=0; i<16; i++)
			for (int j=0; j<16; j++)
				setOutRGB (ct, pt, i, j);
		ColorModel cm = new IndexColorModel (8, 256, outR, outG, outB);
		memImage.newPixels (data, cm, 0, width);
	}

	
	void update () 
	// ȗ
	{
		update (0, 1);
	}
 
	void setOutRGB (int ct, int pt, int c, int p) 
	// update zbgX|bĝŐ؂oĂ݂c
	{
		int at = ct + pt;
		int r = (curR [c] * pt + preR [p] * ct) / at;
		int g = (curG [c] * pt + preG [p] * ct) / at;
		int b = (curB [c] * pt + preB [p] * ct) / at;
		int i = drawFlag ? c * 16 + p : p * 16 + c;

		outR [i] = (byte)r;
		outG [i] = (byte)g;
		outB [i] = (byte)b;
	}
  
	Image createImage (Component cm) 
	// Image IuWFNgĕԂB
	{
		Image image = cm.createImage (memImage);
		return image;
	}
 
} 
  
class GanymeLoader 
// f[^[hB
{
	static Point searchPoint [];

	GanymeFile file; // f[^Et@C
	GanymeScreen screen; // ItEXN[
	int beginPos, endPos; // JbgEf[^̊Jn^Iʒu
	int cutPos [], cutNum; // Jbĝꂼ̈ʒuƑ
	int cutCnt, frameCnt; // Jbgƃt[̃JEg
	Rectangle curRect, preRect, loopRect; // ݁AOA[v̕\`
	int cutWidth, cutHeight; // Jbg̉Əc
	Dimension filmSize, cutSize, frameSize; // tBAJbgAt[̃TCY
		Dimension getFilmSize ()
			{ return new Dimension (filmSize); }
		Dimension getCutSize ()
			{ return new Dimension (cutSize); }
		Dimension getFrameSize ()
			{ return new Dimension (frameSize); }
	Point curLoc, preLoc, loopLoc; // ݁AOA[ṽt[ʒu
		Point getCurLoc ()
			{ return new Point (curLoc); }
		Point getPreLoc ()
			{ return new Point (preLoc); }
	int fps, grade; // ݂̃Jbg FPSA~
		int getTimePerFrame ()
			{ return 1000 / fps; }
	int loopCnt, loopFrame, loopPos; // [ṽJEgAt[AV[Nʒu

	int lenA, lenB; // MAGBIBLE QƂ̂
	byte flagA [], flagB []; // MAGBIBLE QƂ̂
	int posA, posB, posP; // MAGBIBLE QƂ̂
	int cntB; // MAGBIBLE QƂ̂
	
	static { 
		int sp [][] = {
			{0,  0}, {-4,  0}, {-8,  0}, {-16, 0},
			{0, -1}, {-4, -1},
			{0, -2}, {-4, -2}, {-8, -2},
			{0, -4}, {-4, -4}, {-8, -4},
			{0, -8}, {-4, -8}, {-8, -8},
			{0, 0},
		};
		searchPoint = new Point [16];
		for (int i=0; i<16; i++)
			searchPoint [i] = new Point (sp [i][0], sp [i][1]);
	}
 
	GanymeLoader (GanymeScreen sc) 
	{
		screen = sc;

		filmSize = new Dimension ();
		cutSize = new Dimension ();
		frameSize = new Dimension ();

		curRect = new Rectangle ();
		preRect = new Rectangle ();
		loopRect = new Rectangle ();

		curLoc = new Point ();
		preLoc = new Point ();
		loopLoc = new Point ();
	}
 
	public void setFile (GanymeFile fl) 
	// t@CZbg
	{
		file = fl;
		file.seek (0);

		// wb_[̓ǂݎ
		String s;
		int sw, sh; // Screen Width/Height
		int fw, fh; // Film Width/Height
		int sz; // SiZe

		s = new String (file.readBytes (2));
		if (s.equals ("CA")) { // P̂̃Jbg
			// t@C̃TCY
			endPos = file.readInt ();

			// NWbg
			file.skipString ();

			// XN[̍őTCY
			sw = file.readShort ();
			sh = file.readShort ();
			screen.setSize (sw, sh);

			// tB̃TCY
			fw = file.readShort ();
			fh = file.readShort ();
			filmSize.width = fw;
			filmSize.height = fh;

			// Jbg̐ƈʒu
			cutPos = new int [1];
			cutPos [0] = beginPos = 6;
			cutNum = 1;
			file.seek (beginPos);
		} else if (s.equals ("GA")) { // ̃Jbg
			// t@C̃TCY
			endPos = file.readInt ();

			// Җƍi
			file.skipString (); // i
			file.skipString (); // Җ

			// tB̃TCY
			fw = file.readShort ();
			fh = file.readShort ();
			filmSize.width = fw;
			filmSize.height = fh;

			// XN[̍őTCY
			sw = file.readShort ();
			sh = file.readShort ();
			screen.setSize (sw, sh);

			// Jbg̐ƈʒu
			cutNum = file.readShort ();
			cutPos = new int [cutNum];
			for (int i=0; i<cutNum; i++)
				cutPos [i] = file.readInt ();

			// ǂݎʒuƐ[ƏI[
			beginPos = file.tell ();
		} else {
			return;
		}

		// kptO
		sw = screen.getWidth ();
		lenB = sw / 8 + (sw % 8 > 0 ? 1 : 0);
		flagB = new byte [lenB]; // 4 = 2 * 2

		lenA = lenB / 8 + (lenB % 8 > 0 ? 1 : 0);
		flagA = new byte [lenA]; // 64 = 4 * 8

		// ̑̏
		loopCnt = 1;
		cutCnt = 0;
	}
 
	public int update () 
	// Pt[i߂ screen XV
	{
		int pos = file.tell ();
		if (pos == endPos) {
			file.seek (beginPos);
			pos = file.tell ();
			cutCnt = 0;
		}
		if (pos == cutPos [cutCnt]) {
			file.skipString (); // NWbg
			short cw, ch, fw, fh;
			byte fp, gr;
			cw = file.readShort ();
			ch = file.readShort ();
			fw = file.readShort ();
			fh = file.readShort ();
			fp = file.readByte ();
			gr = file.readByte ();
			gr++;
			if (loopCnt < 2) {
				frameCnt = 0;
				if (++cutCnt == cutNum) cutCnt = 0;
				cutWidth = cw;
				cutHeight = ch;
				frameSize.width = fw;
				frameSize.height = fh;
				curRect.setBounds (0, 0, cw, ch);
				fps = fp;
				grade = gr;
				screen.setGrade (grade);
				pos = file.tell ();
			}
		}
		int tm = file.readShort (); // TiMe
		if (frameCnt == 0) tm = Math.abs (tm);
		int lp = file.readShort (); // LooP
		int lm = file.readByte (); // LuMinosity

		int fx, fy; // Frame X, Frame Y
		fx = file.readShort ();
		fy = file.readShort ();

		int dx = file.readShort (); // Draw X
		int dy = file.readShort (); // Draw Y
		int dw = file.readShort (); // Draw Width
		int dh = file.readShort (); // Draw Height
		if (loopCnt > 1 && lp != 0) {
			screen.loadLoop ();
			frameCnt = loopFrame;
			curRect.setBounds (loopRect);
			curLoc.setLocation (loopLoc);
			file.seek (loopPos);
			tm = file.readShort ();
			if (frameCnt == 0) tm = Math.abs (tm);
			lp = file.readShort ();
			lm = file.readByte ();

			fx = file.readShort ();
			fy = file.readShort ();

			dx = file.readShort ();
			dy = file.readShort ();
			dw = file.readShort ();
			dh = file.readShort ();
			loopCnt--;
		} else if (lp > 1) {
			loopCnt = lp;
			loopPos = pos;
			loopFrame = frameCnt;
			loopRect.setBounds (curRect);
			loopLoc.setLocation (curLoc);
			screen.saveLoop ();
		}
		screen.setDrawFlag ((frameCnt++ & 1) == 1);

		preRect.setBounds (curRect);
		curRect.setBounds (dx, dy, dw, dh);

		preLoc.setLocation (curLoc);
		curLoc.setLocation (fx, fy);

		// WJ
		int bsz = file.readInt (); // B flag SiZe
		int psz = file.readInt (); // P flag SiZe
		int y2 = dy + dh;
		int x2 = dx + dw;
		lenB = dw / 8 + (dw % 8 > 0 ? 1 : 0);
		lenA = lenB / 8 + (lenB % 8 > 0 ? 1 : 0);
		for (int i=0; i<lenB; i++)
			flagB [i] = 0x11;
		pos = file.tell ();
		posB = pos + lenA * dh;
		posP = posB + bsz;
		if (cutWidth > screen.getWidth () || cutHeight > screen.getHeight ()) {
			file.seek (posP + psz);
			return tm;
		}

		// Ot[Rs[
		if (dw == 0 || dh == 0)
			screen.copyPrev (preRect.x, preRect.y, preRect.width, preRect.height);
		else {
			Rectangle rc = new Rectangle (curRect);
			rc.add (preRect);
			screen.copyPrev (rc.x, rc.y, rc.width, dy - rc.y); // 
			screen.copyPrev (rc.x, dy, dx - rc.x, dh); // 
			screen.copyPrev (dx + dw, dy, rc.x + rc.width - dx - dw, dh); // E
			screen.copyPrev (rc.x, dy + dh, rc.width, rc.y + rc.height - dy - dh); // 
		}

		if (grade <= 4) for (int y=dy; y<y2; y++) {
			expandFlagB ();
			pos = file.tell ();
			file.seek (posP);
			for (int x=dx; x<x2; x+=4) {
				GanymeDots dt = new GanymeDots (); // DoTs
				int od = getFlagB (); // OrDer
				if (od == 15) // PrevFrame
					dt = screen.prevDots (x, y);
				else if (od == 0) {
					int bt; // ByTe
					bt = file.readByte ();
					for (int i=0; i<4; i++) {
						dt.set (i, bt & 3);
						bt >>= 2;
					}
				} else {
					Point pt = searchPoint [od];
					dt = screen.getDots (x + pt.x, y + pt.y);
				}
				screen.setDots (dt, x, y);
			}
			posP = file.tell ();
			file.seek (pos);
		} else for (int y=dy; y<y2; y++) {
			expandFlagB ();
			pos = file.tell ();
			file.seek (posP);
			for (int x=dx; x<x2; x+=4) {
				GanymeDots dt = new GanymeDots ();
				int od = getFlagB (); // OrDer
				if (od == 15) // PrevFrame
					dt = screen.prevDots (x, y);
				else if (od == 0)
					for (int i=0; i<4;) {
						int bt = file.readByte (); // ByTe
						dt.set (i++, bt & 0xf);
						dt.set (i++, (bt >> 4) & 0xf);
					}
				else {
					Point pt = searchPoint [od];
					dt = screen.getDots (x + pt.x, y + pt.y);
				}
				screen.setDots (dt, x, y);
			}
			posP = file.tell ();
			file.seek (pos);
		}
		file.seek (posP);

		screen.setLumino (lm);
		return tm;
	}
 
	void expandFlagB () 
	// ktOWJ
	{
		for (int i=0; i<lenA; i++)
			flagA [i] = file.readByte ();
		int ps = file.tell (); // PoSition
		file.seek (posB);
		for (int i=0; i<lenB; i++) {
			if (((flagA [i / 8] >> (i % 8)) & 1) != 0)
				flagB [i] = file.readByte ();
		}
		posB = file.tell ();
		file.seek (ps);

		cntB = 0;
	}
 
	int getFlagB () 
	// MAGBIBLE QƂ̂
	{
		int od = flagB [cntB / 2]; // OrDer
		if ((cntB & 1) != 0) {
			od >>= 4;
			od &= 0x0f;
		} else {
			od &= 0x0f;
		}
		cntB++;
		return od;
	}
 
} 
  
public class GanymeApplet extends Applet implements Runnable { 
	Thread thread;
	Image image;
	GanymeLoader loader;
	GanymeScreen screen;
	GanymeFile file;
	Point drawLoc;
	Dimension drawSize;
	Point destX1, destX2, destY1, destY2;
	Point srcX1, srcY1, srcX2, srcY2;
	int time;
	Image off_img;
	boolean playing_flag;
	
	public GanymeApplet () 
	{
		drawLoc = new Point ();
		drawSize = new Dimension ();
	}
 
	public void init () { 
		// 
		try {
			URL url = new URL (getDocumentBase (), getParameter ("file_name"));
			file = new GanymeFile (url);
		} catch (MalformedURLException e) {
		}
		file.start ();

		screen = new GanymeScreen ();

		loader = new GanymeLoader (screen);
		loader.setFile (file);
		drawSize.setSize (screen.getWidth (), screen.getHeight ());
		image = screen.createImage (this);
		off_img = createImage (getSize ().width, getSize ().height);

		playing_flag = false;
	}
 
	public void start() { 
		// Jn
		thread = new Thread (this);
		thread.start ();
		playing_flag = false;
	}

 
	public void stop () { 
		// ꎞ~
		if (thread != null)
			thread = null;
	}
 
	public void run () { 
		long wt, t1, t2; // Wait Time, Time 1, Time 2
		wt = t1 = t2 = 0;
		MemoryImageSource ims;
		while (true) {
			try {
				while (!playing_flag) Thread.sleep (1);
				int fc = loader.update ();
				t2 = System.currentTimeMillis ();
				wt -= t2 - t1;

				// ԑ҂
				if (wt > 0) Thread.sleep (wt);

				// `ƍXV
				int tf; // Time per Frame
				t1 = System.currentTimeMillis ();
				if (fc > 0) {
					// ʂ̍XV
					drawLoc = loader.getCurLoc ();
					drawSize = loader.getFrameSize ();
					screen.update ();

					// ItXN[XV
					tf = loader.getTimePerFrame ();

					// ҂ԂZbg
					wt = tf * fc;
				} else if (fc < 0) {
					// iKIȍXV
					fc = Math.abs (fc);
					drawSize = loader.getFrameSize ();

					int at = fc + 1;  // All Time

					Point cl = loader.getCurLoc (); // Cur Loc
					Point pl = loader.getPreLoc (); // Pre Loc
					tf = loader.getTimePerFrame ();

					for (int ct=fc; ct>0; ct--) { // Cur Time
						int pt = at - ct; // PreTime

						drawLoc.x = (pl.x * ct + cl.x * pt) / at;
						drawLoc.y = (pl.y * ct + cl.y * pt) / at;

						screen.update (ct, pt);

						if (ct > 1) {
							t2 = System.currentTimeMillis ();
							wt = tf - (t2 - t1);
							if (wt > 0) Thread.sleep (wt);
						}
						t1 = System.currentTimeMillis ();
					}

					// ҂ԂZbg
					wt = tf;
				}
			} catch (InterruptedException e) {
			}
		}
	}
 
	public void destroy() { 
		// IiAvbg̔jj
		if (thread != null)
			thread = null;
	}
 
	public void update (Graphics g) { 
		paint(g);
	}
 
	public void paint (Graphics pg) 
	{
		// ItXN[̍XV
		Graphics g = off_img.getGraphics ();

		Dimension as = getSize (); // Applet Size
		Dimension fs = drawSize; // Frame Size
		int x = (as.width - fs.width) / 2;
		int y = (as.height - fs.height) / 2;

		// t[O
		g.setColor (Color.black);
		g.fillRect (0, 0, as.width, y); // 
		g.fillRect (0, y + fs.height, as.width, as.height - y - fs.height); // 
		g.fillRect (0, y, x, fs.height); // 
		g.fillRect (x + fs.width, y, as.width - x - fs.width, fs.height); // E

		// `
		int dx2 = x + fs.width;
		int dy2 = y + fs.height;
		int sx2 = drawLoc.x + fs.width;
		int sy2 = drawLoc.y + fs.height;
		g.drawImage (image, x, y, dx2, dy2, drawLoc.x, drawLoc.y, sx2, sy2, this);

		if (!playing_flag) {
			// Đ𑣂
			String msg = "Click to start.";
			FontMetrics fm = g.getFontMetrics ();
			int mx = (as.width - fm.stringWidth (msg)) / 2;
			int my = (as.height - fm.getHeight ()) / 2;
			g.setColor (Color.green);
			g.drawString (msg, mx, my);
		}

		pg.drawImage (off_img, 0, 0, this);
	}
 
	public boolean mouseDown (Event evt, int x, int y) 
	{
		if (!playing_flag)
			playing_flag = true;
		return true;
	}
 
} 
   
